function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

var styles = {"editorContainer":"_11upT","editor":"_3JHT6","menuBar":"_1f9vr","item":"_1uKxE","menuBarBubbleBottom":"_210GX","menuBarBubbleTop":"__Gxqm","color-white":"_LuPs6","editorLine":"_2YZ7M"};

var styles$1 = {"dialogContainer":"_2K8vL","dialog":"_2iIs6","body":"_13ArV"};

var AddImageComponent = function AddImageComponent(props) {
  var _useState = React.useState(props.show),
      visible = _useState[0],
      setVisible = _useState[1];

  var _useState2 = React.useState(""),
      imageUrl = _useState2[0],
      setImageUrl = _useState2[1];

  React.useEffect(function () {
    setVisible(props.show);
  }, [props.show]);

  var handleChange = function handleChange(event) {
    setImageUrl(event.currentTarget.value);
  };

  var submit = function submit(event) {
    event.preventDefault();
    props.onAddImage(imageUrl);
    props.onHide();
  };

  return visible ? React__default.createElement("div", {
    className: styles$1.dialogContainer
  }, React__default.createElement("div", {
    className: styles$1.dialog
  }, React__default.createElement("div", {
    className: "header"
  }, React__default.createElement("h3", null, "Add Image")), React__default.createElement("form", {
    className: styles$1.body,
    id: "add-img-form",
    onSubmit: submit
  }, React__default.createElement("label", null, "Provide Image URL."), React__default.createElement("input", {
    type: "url",
    value: imageUrl,
    required: true,
    onChange: handleChange
  })), React__default.createElement("div", null, React__default.createElement("button", {
    form: "add-img-form"
  }, "Add Image")))) : null;
};

var Editor = function Editor(props) {
  var _useState = React.useState(false),
      showAddImageDialog = _useState[0],
      setShowAddImageDialog = _useState[1];

  var editor = React.useRef(null);

  var _useState2 = React.useState(null),
      lastFocusPosition = _useState2[0],
      setlastFocusPosition = _useState2[1];

  return React__default.createElement("div", {
    className: styles.editorContainer
  }, props.showActionbar ? props.getActionBar() : null, React__default.createElement("div", {
    ref: editor,
    className: styles.editor,
    contentEditable: true,
    onInput: props.onChange,
    onMouseUp: props.onMouseUp,
    "data-default-value": "Hello",
    onPaste: props.onPaste,
    onDoubleClick: function onDoubleClick() {
      var selection = document.getSelection();
      setlastFocusPosition({
        node: selection === null || selection === void 0 ? void 0 : selection.focusNode,
        offset: selection === null || selection === void 0 ? void 0 : selection.focusOffset
      });
      setShowAddImageDialog(true);
    }
  }), React__default.createElement(AddImageComponent, {
    onAddImage: function onAddImage(imageUrl) {
      return props.onAddImage(imageUrl, editor.current, lastFocusPosition);
    },
    show: showAddImageDialog,
    onHide: function onHide() {
      return setShowAddImageDialog(false);
    }
  }));
};

var EditorAction;

(function (EditorAction) {
  EditorAction[EditorAction["BOLD"] = 0] = "BOLD";
  EditorAction[EditorAction["SNIPT"] = 1] = "SNIPT";
  EditorAction[EditorAction["H1"] = 2] = "H1";
  EditorAction[EditorAction["H3"] = 3] = "H3";
})(EditorAction || (EditorAction = {}));

var EditorContainer = function EditorContainer(props) {
  var _useState = React.useState({
    x: 0,
    y: 0
  }),
      barPosition = _useState[0],
      setBarPosition = _useState[1];

  var _useState2 = React.useState(false),
      showActionBar = _useState2[0],
      setShowActionBar = _useState2[1];

  var _useState3 = React.useState(null),
      lastSelection = _useState3[0],
      setLastSelection = _useState3[1];

  var onChange = function onChange(event) {
    var value = event.target.innerHTML;
    console.log(value);
    props.onChange(value);
    if (showActionBar) setShowActionBar(false);
  };

  var onMouseUp = function onMouseUp(_) {
    setTimeout(function () {
      return handleSelection();
    }, 100);
  };

  var handleSelection = function handleSelection() {
    var textSelection = document.getSelection();

    if (textSelection && textSelection.rangeCount > 0) {
      var oRange = textSelection === null || textSelection === void 0 ? void 0 : textSelection.getRangeAt(0);
      var oRect = oRange === null || oRange === void 0 ? void 0 : oRange.getBoundingClientRect();

      if (textSelection && textSelection.toString() !== "") {
        setLastSelection(textSelection);
      }

      setShowActionBar((textSelection === null || textSelection === void 0 ? void 0 : textSelection.toString()) != "");
      setBarPosition({
        x: ((oRect === null || oRect === void 0 ? void 0 : oRect.x) || 0) + ((oRect === null || oRect === void 0 ? void 0 : oRect.width) || 0) / 2,
        y: (oRect === null || oRect === void 0 ? void 0 : oRect.y) || 0
      });
    }
  };

  var showMenuBar = function showMenuBar(x, y) {
    var py = y - 45;
    var px = x - 100;
    var bubble = styles.menuBarBubbleBottom;

    if (py < 0) {
      py = y + 28;
      bubble = styles.menuBarBubbleTop;
    }

    if (px < 0) {
      px = 0;
    } else if (px > window.innerWidth - 215) {
      px = window.innerWidth - 215;
    }

    return React__default.createElement("div", {
      className: styles.menuBar + " " + bubble,
      style: {
        left: px,
        top: py
      }
    }, React__default.createElement("span", {
      className: styles.item + " bi-type-bold",
      onMouseDownCapture: function onMouseDownCapture() {
        return doAction(EditorAction.BOLD);
      }
    }), React__default.createElement("span", {
      className: styles.item + " bi-type-h1",
      onMouseDownCapture: function onMouseDownCapture() {
        return doAction(EditorAction.H1);
      }
    }), React__default.createElement("span", {
      className: styles.item + " bi-type-h3",
      onMouseDownCapture: function onMouseDownCapture() {
        return doAction(EditorAction.H3);
      }
    }));
  };

  var onPaste = function onPaste(event) {
    event.preventDefault();
    var text = event.clipboardData.getData('text/plain');
    var files = event.clipboardData.files;
    console.log(event.clipboardData);

    if (files.length > 0) {
      console.log("Image here", files);
      FileUtil.toBase64(files[0]).then(function (data) {
        console.log(data);
      });
    } else {
      document.execCommand('insertText', false, text);
    }
  };

  var doAction = function doAction(action) {
    switch (action) {
      case EditorAction.BOLD:
        document.execCommand('bold', false, "");
        break;

      case EditorAction.H1:
        document.execCommand('formatBlock', false, "h1");
        break;

      case EditorAction.H3:
        document.execCommand('formatBlock', false, "h3");
        break;
    }

    lastSelection === null || lastSelection === void 0 ? void 0 : lastSelection.empty();
    setShowActionBar(false);
  };

  var onAddImage = function onAddImage(url, editor, lastPosition) {
    if (editor) editor.focus();
    var selection = document.getSelection();
    console.log(lastPosition);

    if (selection) {
      selection.collapse((lastPosition === null || lastPosition === void 0 ? void 0 : lastPosition.node) || null, lastPosition === null || lastPosition === void 0 ? void 0 : lastPosition.offset);
    }

    setTimeout(function () {
      document.execCommand("insertImage", true, url);
      document.execCommand("insertParagraph", true, "");
    }, 100);
  };

  return React__default.createElement(Editor, {
    showActionbar: showActionBar,
    onMouseUp: onMouseUp,
    onChange: onChange,
    getActionBar: function getActionBar() {
      return showMenuBar(barPosition.x, barPosition.y);
    },
    onPaste: onPaste,
    onAddImage: onAddImage
  });
};

var Editoract = function Editoract(props) {
  return React.createElement(EditorContainer, {
    onChange: props.onChange
  });
};

exports.Editoract = Editoract;
//# sourceMappingURL=index.js.map
